/********************************************************************
Functions for Particle class.
********************************************************************/

#include "Particle.h"

/********************* Default constructor ******************/
Particle::Particle(void)
{
	Particle(0, 0, 0, 0);
}

/******************* Initializer constructor ********************/
Particle::Particle(double xInput, double yInput, double vxInput, double vyInput)
{
	position(0) = xInput;
	position(1) = yInput;
	velocity(0) = vxInput;
	velocity(1) = vyInput;
}

/**** Function to return a pointer to access the position vector *****/
/******* but without allowing the caller to modify the values ********/
const VECTOR_2D<double>& Particle::getPosition()
{
	return position;
}


/**** Function to return a pointer to access the velocity vector *****/
/******** but without allowing the calle to modify the values ********/
const VECTOR_2D<double>& Particle::getVelocity()
{
	return velocity;
}

/********************* Destructor ***********************/
Particle::~Particle(void)
{
}
