/********************************************************************
Class to represent a rounded set of particles.
********************************************************************/

#pragma once

#include "Particle.h"
#include <vector>
#include <iostream>

using namespace ALGEBRA;

class SnowBall
{
private:
	std::vector<Particle> particles;	//A dynamic vector with particles.
	VECTOR_2D<double> center;			//Center of snowball in world coordinates.
	VECTOR_2D<double> velocity;			//Assign same velocity to all particles in snowball.
	double radius;						//radius, should be less than 0.25.
	int numberOfParticles;				//Store how many particles there are, depending on the areas.
	double PI;

public:
	SnowBall(const VECTOR_2D<double>& centerInput, const VECTOR_2D<double>& v, double radiusInput, double area);
	~SnowBall(void);
	const std::vector<Particle>& getParticles();

private:
	void createSnowBall();
};

