#ifndef _file_io_
#define _file_io_

#include <iostream>
#include <fstream>
#include <cstdlib>
#include "algebra.h"
//#include "GEOMETRY.h"

using namespace ALGEBRA;

namespace READ_WRITE{
template <class T>
class FILE_IO{
	
public:
	FILE_IO(){}
	
	/*void Write_Geometry_Dat_Info_File(std::string directory,std::string name,LIST<int>& mesh_info){
		std::ofstream outdata;
		std::string filename(directory+std::string("/")+name+std::string("_info.dat"));
		outdata.open(filename.c_str()); // opens the file
		
		assert(mesh_info.Size()>=2);
		
		outdata << mesh_info(0) << std::endl;
		outdata << mesh_info(1) << std::endl;
		outdata.close();
	}
	
	void Write_Geometry_Dat_Mesh_File(std::string directory,std::string name,GEOMETRY::TETRAHEDRON_MESH& mesh){
		std::ofstream outdata;
		std::string filename(directory+std::string("/")+name+std::string(".dat"));
		outdata.open(filename.c_str());
		
		for(int t=0;t<mesh.Number_Of_Tetrahedra();t++){
			VECTOR_4D<int>& nodes=mesh.Nodes_Of_Element(t);
			for(int i=0;i<4;i++){
				outdata << (nodes(i)+1) << std::endl;}}
		outdata.close();
	}
	
	void Write_Geometry_Dat_Particles(std::string directory,std::string name,VECTOR<T>& positions){
		std::ofstream outdata;
		std::string filename(directory+std::string("/")+name+std::string(".dat"));
		outdata.open(filename.c_str());
		
		for(int p=0;p<positions.Size()/3;p++){
			for(int i=0;i<3;i++) outdata << positions(3*p+i) << std::endl;}
		outdata.close();
	}
	
	void Read_Geometry_Dat_Info_File(std::string directory,std::string name,LIST<int>& mesh_info){
		std::ifstream indata; // indata is like cin
		std::string filename(directory+std::string("/")+name+std::string("_info.dat"));
		indata.open(filename.c_str()); // opens the file
		//Make sure the file exists
		if(!indata) { // file couldn't be opened
			std::cerr << "Error: file could not be opened" << std::endl;
			exit(1);}
		
		//Start parsing
		int number_particles,number_elements;
		//Read mesh info
		indata >> number_particles;
		indata >> number_elements;
		indata.close();
		
		assert(mesh_info.Size()==2);
		mesh_info(0)=number_particles;
		mesh_info(1)=number_elements;
	}
	
	void Read_Geometry_Dat_Mesh_File(std::string directory, std::string name, GEOMETRY::TETRAHEDRON_MESH& mesh){
		
		std::ifstream indata; // indata is like cin
		std::string filename(directory+std::string("/")+name+std::string(".dat"));
		
		indata.open(filename.c_str());
		//Make sure the file exists
		if(!indata) { // file couldn't be opened
			std::cerr << "Error: file could not be opened" << std::endl;
			exit(1);}
		for(int t=0;t<mesh.Number_Of_Tetrahedra();t++){
			VECTOR_4D<int>& nodes=mesh.Nodes_Of_Element(t);
			for(int i=0;i<4;i++){
				indata >> nodes(i);
				nodes(i)-=1;}}
		indata.close();
	}
	
	void Read_Geometry_Dat_Particles(std::string directory, std::string name,VECTOR<T>& positions){
		
		std::ifstream indata; // indata is like cin
		std::string filename(directory+std::string("/")+name+std::string(".dat"));
		indata.open(filename.c_str());
		//Make sure the file exists
		if(!indata) { // file couldn't be opened
			std::cerr << "Error: file could not be opened" << std::endl;
			exit(1);}
			for(int p=0;p<positions.Size()/3;p++){
				for(int i=0;i<3;i++) indata >> positions(3*p+i);}
			indata.close();
	}
	 */
};

static void Write_Binary(std::string directory, std::string name,VECTOR<double>& v){
	std::string filename(directory+std::string("/")+name+std::string(".bin"));
	std::ofstream outdata(filename.c_str(),std::ios::out|std::ios::binary);	
	outdata.write(reinterpret_cast<char*>(v.Raw_Pointer()),sizeof(double)*v.Size());
	outdata.close();
}
	
static void Read_Binary(std::string directory, std::string name,VECTOR<double>& v){
	std::string filename(directory+std::string("/")+name+std::string(".bin"));
	std::ifstream indata(filename.c_str(),std::ios::in|std::ios::binary);	
	indata.read(reinterpret_cast<char*>(v.Raw_Pointer()),sizeof(double)*v.Size());
	indata.close();
}	

static void Write_Binary(std::string directory, std::string name,VECTOR<float>& v){
	std::string filename(directory+std::string("/")+name+std::string(".bin"));
	std::ofstream outdata(filename.c_str(),std::ios::out | std::ios::binary);
	outdata.write(reinterpret_cast<char*>(v.Raw_Pointer()),sizeof(float)*v.Size());
	outdata.close();
}
	
static void Read_Binary(std::string directory, std::string name,VECTOR<float>& v){
	std::string filename(directory+std::string("/")+name+std::string(".bin"));
	std::ifstream indata(filename.c_str(),std::ios::in|std::ios::binary);	
	indata.read(reinterpret_cast<char*>(v.Raw_Pointer()),sizeof(float)*v.Size());
	indata.close();
}	

static void Write_Binary(std::string directory, std::string name,VECTOR<int>& v){
	std::string filename(directory+std::string("/")+name+std::string(".bin"));
	std::ofstream outdata(filename.c_str(),std::ios::out | std::ios::binary);
	outdata.write(reinterpret_cast<char*>(v.Raw_Pointer()),sizeof(int)*v.Size());
	outdata.close();
}
	
static void Read_Binary(std::string directory, std::string name,VECTOR<int>& v){
	std::string filename(directory+std::string("/")+name+std::string(".bin"));
	std::ifstream indata(filename.c_str(),std::ios::in|std::ios::binary);	
	indata.read(reinterpret_cast<char*>(v.Raw_Pointer()),sizeof(int)*v.Size());
	indata.close();
}		
	
}
#endif